﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MeshVR;
using SimpleJSON;


namespace HuntingSuccubus {
	public class EyeballShadowAutoLoader : MVRScript {
		protected JSONStorableFloat Tess;
		protected JSONStorableFloat TessPhong;
		protected JSONStorableFloat ScanTiming;
	DAZClothingItem item1;
	DAZClothingItem item2;
	DAZClothingItem item3;		
    private Atom _person;
    private DAZCharacterSelector _selector;
    private bool _dirty;
    private DAZCharacter _character;
	protected int timer = 1;
		public override void Init() {
			try {
				// put init code in here
				//SuperController.LogMessage("Template Loaded");

				// create custom JSON storable params here if you want them to be stored with scene JSON
				// types are JSONStorableFloat, JSONStorableBool, JSONStorableString, JSONStorableStringChooser
				// JSONStorableColor

			ScanTiming = new JSONStorableFloat("Scan Timing", 200f, 100f, 1000f, true, true);
			RegisterFloat(ScanTiming);
			CreateSlider(ScanTiming, false);

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// Start is called once before Update or FixedUpdate is called and after Init()
		void kStart() {
			try {
            _person = containingAtom;
            _selector = _person.GetComponentInChildren<DAZCharacterSelector>();
			item1 = _selector.clothingItems.First(h => h.displayName == "EyeBall Shadow");
			_selector.SetActiveClothingItem(item1, true);

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		void Update() {
			try {//SuperController.LogError("timer="+timer);
				if (timer>=ScanTiming.val)
				{timer = 0;
					//SuperController.LogError("timer000000000="+timer);
				foreach (Atom atom in FindObjectsOfType(typeof(Atom))) {
				//SuperController.LogError("atom="+atom.name+" atomtype="+atom.type);
			if (atom.type=="Person") 
			{
			//SuperController.LogMessage("-----------AtomType=Person Found------------");
			
			_person = atom;
			//_person = containingAtom;
			_selector = _person.GetComponentInChildren<DAZCharacterSelector>();
			_character = _selector.selectedCharacter;
			bool foundEnhancedEyes = false;
			bool foundReflection = false;
			var skin = _character.skin;
			if (skin == null) return;
			item1 = _selector.clothingItems.First(h => h.displayName == "EyeBall Shadow");
			item2 = _selector.clothingItems.First(h => h.displayName == "EyeBall Iris Reflection");
			//item3 = _selector.clothingItems.First(h => h.displayName == "EyeBall Iris Reflection");
			var allWraps = _person.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);
			       foreach (var wrap in allWraps)
					{
					if (wrap.ToString().Contains("Enhanced Eyes")||wrap.ToString().Contains("Enhanced_Eyes")) 
						{
						//SuperController.LogError("Enhanced Eyes found");
						foundEnhancedEyes = true;
						}
					if (wrap.ToString().Contains("Reflection")||wrap.ToString().Contains("Reflction")) 
						{
						//SuperController.LogError("Reflections found");
						foundReflection = true;
						}	
					}
					if (!foundEnhancedEyes) 
						{
						_selector.SetActiveClothingItem(item1, true);
						}
					if (!foundReflection) 
						{
						_selector.SetActiveClothingItem(item2, true);
						}
			}
			}
			
			}
			timer = timer+1;
			}
			catch (Exception e) {
				//SuperController.LogError("Exception caught: " + e);
			}
		}



		void OnDestroy() {
		}

	}
}